package com.rf.psychological.scale.resultBusiness.scaleResult;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.rf.psychological.utils.Constant;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

/**
 * @description 双相情感障碍自评量表
 */
public class BDQScale extends BaseScale {
    public BDQScale(JSONArray jsonArray, JSONObject resultJson) {
        super(jsonArray, resultJson);
    }

    public JSONObject scaleCalculate() throws Exception {
        //得分
        int score = 0;

        for (int i = 0; i < jsonArray.size(); i++) {
            JSONObject jsonObject1 = jsonArray.getJSONObject(i);

            if (jsonObject1.getString("checkItems").equals("完全不符或几乎不符")) {
                score += 0;
            } else if (jsonObject1.getString("checkItems").equals("稍微符合")) {
                score += 1;
            } else if (jsonObject1.getString("checkItems").equals("有点符合")) {
                score += 2;
            } else if (jsonObject1.getString("checkItems").equals("比较符合")) {
                score += 3;
            } else if (jsonObject1.getString("checkItems").equals("较多符合")) {
                score += 4;
            } else if (jsonObject1.getString("checkItems").equals("非常符合或完全符合")) {
                score += 5;
            }
        }
        //得分列表
        Map<String, String> resultMap = new LinkedHashMap<>();
        resultMap.put("总分", String.valueOf(score));
        resultJson.put("总分", String.valueOf(score));

        if (score <= 15 && score >= 0) {
            resultMap.put("结论", "经过检测您为【单相抑郁】，为了您和家人的幸福，建议您联系我们，进行更专业的检测。（以上测试结果仅供参考）");
            resultJson.put("结论", "经过检测您为【单相抑郁】，为了您和家人的幸福，建议您联系我们，进行更专业的检测。（以上测试结果仅供参考）");
        } else if (score <= 24 && score >= 16) {
            resultMap.put("结论", "经过检测您为【重抑郁轻躁狂】，为了您和家人的幸福，建议您联系我们，进行更专业的检测。（以上测试结果仅供参考）");
            resultJson.put("结论", "经过检测您为【重抑郁轻躁狂】，为了您和家人的幸福，建议您联系我们，进行更专业的检测。（以上测试结果仅供参考）");
        } else if (score <= 60 && score >= 25) {
            resultMap.put("结论", "经过检测您为【双相情感障碍】，为了您和家人的幸福，建议您联系我们，进行更专业的检测。（以上测试结果仅供参考）");
            resultJson.put("结论", "经过检测您为【双相情感障碍】，为了您和家人的幸福，建议您联系我们，进行更专业的检测。（以上测试结果仅供参考）");
        }

        List<Map<String, String>> resultMapList = new ArrayList<>();
        resultMapList.add(resultMap);

        JSONObject returnJson = new JSONObject(true);
        returnJson.put("resultMapList", resultMapList);
        returnJson.put("scaleName", Constant.SHEET_NAME_BDQ);
        returnJson.put("resultJson", resultJson);

        return returnJson;
    }
}
